"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _ramda = require("ramda");

var R = _interopRequireWildcard(_ramda);

var _jecJask = require("jec-jask");

var _filterByCLICommands = require("./filterByCLICommands");

var _filterByCLICommands2 = _interopRequireDefault(_filterByCLICommands);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var generateWorkflowEventActions = function generateWorkflowEventActions(eventName) {
	return function (_ref) {
		var state = _ref.state,
		    filter = _ref.filter;

		var filterUUIDs = (0, _filterByCLICommands2.default)(filter);
		var applyToUUIDs = (0, _jecJask.collateAllObjects)(state).filter(filterUUIDs).map(R.prop("uuid"));

		var actions = applyToUUIDs.map(function (objId) {
			return {
				objId: objId,
				prop: eventName,
				type: "SET_PROP",
				value: new Date().toISOString()
			};
		});

		return {
			actions: actions,
			filterForRender: eventName === "done" ? R.T : filterUUIDs
		};
	};
};

exports.default = generateWorkflowEventActions;