"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _toArray2 = require("babel-runtime/helpers/toArray");

var _toArray3 = _interopRequireDefault(_toArray2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _ramda = require("ramda");

var R = _interopRequireWildcard(_ramda);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parseDataInterface = R.cond([[R.test(/^\+\w+/), R.pipe(R.replace("+", ""), R.objOf("plusTag"))], [R.test(/^-\w+/), R.pipe(R.replace("-", ""), R.objOf("minusTag"))], [R.test(/[\w ]+:[\w ]+/), R.pipe(R.split(":"), function (_ref) {
	var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
	    prop = _ref2[0],
	    value = _ref2[1];

	return {
		prop: prop,
		value: value
	};
})], [function (x) {
	return parseInt(x, 10);
}, function (x) {
	return { int: parseInt(x, 10) };
}], [R.T, function (plain) {
	return { plain: plain };
}]]);

var combinePlains = R.pipe(R.reduce(function (_ref3, val) {
	var arr = _ref3.arr,
	    plain = _ref3.plain;

	if (val.plain) {
		return {
			arr: arr,
			plain: plain.length ? plain + " " + val.plain : val.plain
		};
	} else {
		return {
			arr: [].concat((0, _toConsumableArray3.default)(arr), [val]),
			plain: plain
		};
	}
}, {
	arr: [],
	plain: ""
}), function (_ref4) {
	var arr = _ref4.arr,
	    plain = _ref4.plain;
	return [].concat((0, _toConsumableArray3.default)(arr), [plain.length ? { prop: "description", value: plain } : null]);
}, R.filter(Boolean));

var commandStrings = ["add", "modify", "delete", "start", "stop", "done"];

var parseCli = R.pipe(R.slice(2, Infinity), R.splitWhen(R.contains(R.__, commandStrings)), function (_ref5) {
	var _ref6 = (0, _slicedToArray3.default)(_ref5, 2),
	    filter = _ref6[0],
	    _ref6$ = (0, _toArray3.default)(_ref6[1]),
	    command = _ref6$[0],
	    modifications = _ref6$.slice(1);

	return {
		filter: filter,
		command: command,
		modifications: modifications
	};
}, R.evolve({
	filter: R.map(parseDataInterface),
	modifications: R.map(parseDataInterface)
}), R.evolve({
	filter: combinePlains,
	modifications: combinePlains
}));

exports.default = parseCli;