"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _ramda = require("ramda");

var _ramda2 = _interopRequireDefault(_ramda);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var measureColumnWidths = function measureColumnWidths(config) {
	return _ramda2.default.reduce(function (columnWidths, task) {
		return (0, _extends3.default)({}, columnWidths, _ramda2.default.pipe(_ramda2.default.toPairs, _ramda2.default.filter(function (_ref) {
			var _ref2 = (0, _slicedToArray3.default)(_ref, 1),
			    key = _ref2[0];

			return _ramda2.default.contains(key, config.headers);
		}), _ramda2.default.map(function (_ref3) {
			var _ref4 = (0, _slicedToArray3.default)(_ref3, 2),
			    key = _ref4[0],
			    value = _ref4[1];

			return [key, Math.max(key.length || 0, value.length || 0, columnWidths[key] || 0, 0)];
		}), _ramda2.default.fromPairs)(task));
	}, {});
};

exports.default = function (config) {
	return _ramda2.default.pipe(measureColumnWidths(config), _ramda2.default.pipe(_ramda2.default.toPairs, _ramda2.default.map(function (_ref5) {
		var _ref6 = (0, _slicedToArray3.default)(_ref5, 2),
		    label = _ref6[0],
		    length = _ref6[1];

		return {
			label: label,
			length: length
		};
	}), _ramda2.default.sortBy(function (_ref7) {
		var label = _ref7.label;
		return _ramda2.default.findIndex(_ramda2.default.equals(label), config.headers);
	})));
};